#include<iostream>
#include<stdlib.h>
#include<time.h>
using namespace std;



/*GLOBAL VARIABLES:*/
const int beg_x=9,beg_y=9,beg_n=10,intmid_x=16,intmid_y=16,intmid_n=40,adv_x=30,adv_y=16,adv_n=99;
char proboard[100][100],gameboard[100][100],newgm;
int l,b,n,c=2,test[100][100];
/**********************************
*FOLLOWING FUNCTION DISPLAYS MENU *
**********************************/
void dispmenu()
{

    cout<<"***********************MENU***********************"<<endl;
    cout<<"*1.BEGINNER                                      *"<<endl;
    cout<<"*2.INTERMEDIATE                                  *"<<endl;
    cout<<"*3.ADVANCED                                      *"<<endl;
    cout<<"*4.EXIT                                          *"<<endl;
    cout<<"**************************************************"<<endl;


}   /**end of menu func.n
/**FUNCTION FOR ENTERING YOUR CHOICE**/
char yourchoice()
{
    char choice;
    cout<<"\nenter your choice:";
    cin>>choice;
    return choice;
}
void Toquit()
{
    exit(0);
}
/************************************
 *VARIABLE l,b AND n ARE ASSIGNED TO*
 *THEIR CORRESPONDING VALUES FOR    *
 *BEGINNER,INTERMEDIATE OR ADVANCE  *
 ************************************/

void getgameinfo(char ch)
{
    switch(ch)
    {
        case '1':l=beg_x;
                 b=beg_y;
                 n=beg_n;
                 break;
        case '2':l=intmid_x;
                 b=intmid_y;
                 n=intmid_n;
                 break;
        case '3':l=adv_x;
                 b=adv_y;
                 n=adv_n;
                 break;
        case '4':Toquit();
    }
   }/**********************************************************************************
    *now  l,b,n contain required information about the game(size and number of mines)*
    **********************************************************************************/
//////////////////
/******************************************************************************************
 *Add a mine to our gameboard                                                             *
 *returns true if mine added                                                              *
 *false if mine wasn't added (attempted to add a mine to a location that already had one) *
 *also updates proximity values in the map as well                                        *
 ******************************************************************************************/
bool loadboard()
     {
         int x,y;
         /**GENERATING RANDOM COORDINATES FOR PLACING MINE**/
         x=rand()%l;
         y=rand()%b;
         /**ADD THE MINE IF NOT ALREADY PRESENT**/
         if(gameboard[x][y] != '*')
	{
		gameboard[x][y] = '*';
		/***walk through all neighboring locations and increment their proximity counts***/
		for(int dx = x-1; dx <= x+1; dx++)
			for(int dy = y-1; dy <= y+1; dy++)
				if(dx >= 0 && dx < l && dy >= 0 && dy < b)
					if(gameboard[dx][dy] != '*') /**Don't update proximity count for mine locations**/
						if(gameboard[dx][dy] == '.')
							gameboard[dx][dy] = '1'; /**initial proximity, set to 1**/
						else
							gameboard[dx][dy]++; /**otherwise, increment current count (works even with chars so long as count never exceeds 9)**/
		return true;
	}

	/**random location already contains a mine**/
	return false;
}
//////////////////////

 void func(int p,int q)
         {    int i,j;

             for(i=p-1;i<=p+1;i++)
             {
                 for(j=q-1;j<=q+1;j++)
                 {

                     if(gameboard[i][j]!='*' && i>=0 && i<l && j>=0 && j<b && test[i][j]==0)
                     {
                         proboard[i][j]=gameboard[i][j];
                         test[i][j]=1;
                         if(i==p&&j==q){test[i][j]=2;}
                     }
                 }
             }
             test[p][q]=2;
             for(i=p-1;i<=p+1;i++)
             {
                 for(j=q-1;j<=q+1;j++)
                 {
                     if(gameboard[i][j]=='.' && i>=0 && i<l && j>=0 && j<b && test[i][j]!=2)
                     {    int m=i,n=j;
                         func(m,n);

                     }
                 }
             }
             return;
         }/**END OF FUNCTION**/
bool revealLocation(int x,int y)
{
     int i,j;
    /**gameboard[x][y]='.';
     IF SPECIFIED LOCATION HAS MINE->"GAME OVER" and function returns true**/
    if (gameboard[x][y]=='*')
        return true;
   /***********************************************
    *If our location isn't in proximity to a mine *
	*we reveal all neighboring locations          *
	*dots indicate no neighboring mine            *
	***********************************************/
	else if(gameboard[x][y]!='.')
    {
        proboard[x][y]=gameboard[x][y];
         return false;
    }
    else if(gameboard[x][y]=='.')
    {
       func(x,y);
       return false;
    }
}
int counthash()
{
	int count = 0;
	for(int x = 0; x < l; x++)
		for(int y = 0; y < b; y++)
			if(proboard[x][y] == '#') count++;

	return count;
}
void disploseboard(int x,int y)
{
    int i,j;
    for(i=0;i<l;i++)
    {
       cout<<"        ";
        for(j=0;j<b;j++)
        {
            if(i==x &&j==y)
                proboard[i][j-1]='@';
            else if(proboard[i][j]=='#')
            {
                proboard[i][j]=gameboard[i][j];
            }
            std::cout.width(3);
           std::cout<<proboard[i][j];
        }
        cout<<endl;
        cout<<endl;
    }
}


bool newgame(char c)
{
    if(c=='y'|| c=='Y')
        return true;
    else if(c=='n' || c=='N')
        return false;
}
int main()
{

 do
 {




    srand((unsigned int)time(NULL));
    int i,j;

	/*********************************************************
	 *gameboard contains our mines and proximity values      *
	 *Only unmasked locations of map will be visible though  *
	 *as tracked by our following proboard matrix            *
	 *********************************************************/
    dispmenu();
    /***************************************
     *proboard tracks revealed locations   *
	 *# char indicates unrevealed locations*
     *char indicated revealed locations    *
     ***************************************/
    char ch=yourchoice();
    /**now ch will contain choice**/

    getgameinfo(ch);

    for(i=0;i<l;i++)
    {

        for(j=0;j<b;j++)
        {
            test[i][j]=0;
        }
    }
     /**now initializing the values in 2-D matrices with corresponding character constants**/
    for( i=0;i<l;i++)
    {

        for(j=0;j<b;j++)
        {

            proboard[i][j]='#';
            gameboard[i][j]='.';
        }
    }/**initialized**/
    int minecount=0;
    /**loop add mines randomly until we have full mine field**/
    do
    {
        if(loadboard())
        {
            minecount++;
        }

    }while(minecount!=n);
    /**CHOOSE COORDINATES OF GRID YOU WANT TO OPEN**/
    int x_in,y_in;
    /**oop to add mines until we have a full minefield**/

	do
	{
		/**loop through our rows**/
		cout<<"                ";
		for(int i=0;i<b;i++)
        {
            if(i<9)
                cout<<"  "<<(i+1);
            else{
                cout<<" "<<(i+1);
            }
        }
        cout<<endl;
        cout<<"               ";
        for(int i=0;i<3*b+2;i++)
        {
            cout<<"^";
        }
        cout<<endl;
		for(int x = 0; x < l; x++)
		{ if(x<9)
		{
		    cout<<"            ";
		}
		else
        {
             cout<<"           ";
        }


			/**output each row index before the row itself**/
			cout << x+1<<"  |";

			/**loop through all the columns for this row**/
			for(int y = 0; y < b; y++)
			{

				/************************************************
				 *if location is still masked, display mask char*
				 *otherwise display the underlying map value    *
				 ************************************************/
				if(proboard[x][y] == '#')

					{std::cout.width(3);

                    std::cout << '#';}
				else
					{std::cout.width(3);

					    std::cout << gameboard[x][y];}


			}cout << endl;
			cout<<endl;
		}
   cout<<"\n enter coordinates :"<<endl;
    cin>>x_in>>y_in;

        /************************************************************
         *pass the specified location to our revealLocation function*
		 *revealLocation returns true if a mine was unmasked        *
		 ************************************************************/
		if(revealLocation(x_in-1, y_in-1))
		{
			cout << "You set off a mine.GAME OVER! better luck next time!" << endl;
			break;
		}

		/******************************************************************
         *Count our masked location, if == beg_n, then only mines are left*
		 *and player has won the game                                     *
		 ******************************************************************/
		if(counthash() == n)
		{
			cout<< "You have found all the mines.  Congratulations!" << endl;

            break;
		}

	}while(1);


if(counthash()!=n)
{     cout<<"\n";
cout<<endl;
    disploseboard(x_in-1,y_in);


}
cout<<"WANT TO PLAY AGAIN?->'y' or 'n'";
cin>>newgm;
 }while(newgame(newgm));

    return 0;
}     /**********end of main()*****************/
